<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionGrafica }}</strong>
    </div>
    <v-card flat class="pa-10">
      <div class="titSec">
        {{ textoGestionGrafica }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <v-row>
        <v-col :cols="12" :sm="12" :md="6" :lg="4" :xl="4">
          Clave
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="grafica.clave"
            outlined
            solo
            maxlength="100"
            flat
            dense
            v-less-spaces
            v-lower-case
            :error="$v.grafica.clave.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(grafica.clave, 100)
            "
            background-color="white"
          >
            <template v-if="$v.grafica.clave.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.grafica.clave.$reset" v-close-popover>
                    <div v-if="!$v.grafica.clave.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="4" :xl="4">
          Descripción
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="grafica.descripcion"
            outlined
            solo
            maxlength="50"
            flat
            dense
            :error="$v.grafica.descripcion.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(grafica.descripcion, 50)
            "
            background-color="white"
          >
            <template v-if="$v.grafica.descripcion.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.grafica.descripcion.$reset" v-close-popover>
                    <div v-if="!$v.grafica.descripcion.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
        <v-col :cols="12" :sm="12" :md="12" :lg="4" :xl="4">
          Notas
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="grafica.notas"
            outlined
            solo
            maxlength="200"
            flat
            dense
            :error="$v.grafica.notas.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(grafica.notas, 200)
            "
            background-color="white"
          >
            <template v-if="$v.grafica.notas.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.grafica.notas.$reset" v-close-popover>
                    <div v-if="!$v.grafica.notas.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
      </v-row>
      <div class="btnCenter">
        <v-btn
          class="mr-sm-6 mb-2 mb-sm-0"
          depressed
          :block="$vuetify.breakpoint.xs"
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          :block="$vuetify.breakpoint.xs"
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingGrafica },
            { 'error-validation-btn': $v.$invalid },
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </v-card>
    <!-- Dialogs-->
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh!</strong>
            Tienes algunos conflictos de validación
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡No hay de que preocuparse! Solo tienes que corregirlos
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh! Advertencia</strong>
            <v-icon right color="orange">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh...! </strong>
            Todo salió bien
            <v-icon right color="green">mdi-check-circle-outline</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡Tus datos fueron guardados!
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                :to="toEditGrafica()"
                >Entiendo</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.titSec .tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-NuevaGrafica",
  components: {
    LeavePage,
  },
  data() {
    return {
      savingGrafica: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      graficaBackup: {
        idGrafica: null,
        descripcion: "",
      },
      grafica: {
        idGrafica: null,
        descripcion: "",
      },
      textoGestionGrafica: null,
    };
  },
  computed: {
    breadcrumbs() {
      return [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Sistema de Información",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion",
          },
        },
        {
          text: "Dashboard",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion_dashboard",
          },
        },
        {
          text: "Gráficas",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion_dashboard_v2_graficas",
          },
        },
        {
          text: "Nueva",
          disabled: true,
        },
      ];
    },
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.graficaBackup) {
        const originalValue = JSON.stringify(this.graficaBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.grafica).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.grafica.idGrafica === undefined;
      }
    },
  },
  validations: {
    grafica: {
      descripcion: {
        required,
      },
      notas: {
        required,
      },
      clave: {
        required,
      },
    },
  },
  methods: {
    guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.savingGrafica = true;
        let body = {
          clave: this.grafica.clave,
          descripcion: this.grafica.descripcion,
          notas: this.grafica.notas,
        };
        axios
          .post("/sistema-informacion/tablero/graficas/v1/", body)
          .then((response) => {
            let data = response.data;
            if (data) {
              this.grafica.idGrafica = data.resultado.id;
            }
            this.graficaBackup = JSON.parse(JSON.stringify(this.grafica));
            this.dialogSave = true;
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          })
          .finally(() => {
            this.savingGrafica = false;
          });
      } else {
        this.dialogErrorValidation = true;
      }
    },
    toEditGrafica() {
      return {
        name: "sistema_informacion_dashboard_v2_graficas_edicion",
        params: {
          grafica: this.serviceCommons.objectToBase64(this.grafica),
        },
      };
    },
    cancelGlobalChanges() {
      this.grafica = JSON.parse(JSON.stringify(this.graficaBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    initValues() {
      this.textoGestionGrafica = "Crear Gráfica";
    },
  },
  created() {
    this.graficaBackup = JSON.parse(JSON.stringify(this.grafica));
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  },
};
</script>
